$APPTYPE GUI: $TYPECHECK ON
$resource hot_basic as "hotbasic.bmp"
$resource hotpic1 as "hotpic1.bmp"

DIM mybmp As BITMAP
with mybmp
.bmp = "hotpic1"
.xsize = 80
.ysize = 80
end with

RANDOMIZE TIMER
DEFINT cWidth, cHeight, tcolor, hDC, i, j, k=1
DEFINT dWidth,dHeight
DEFINT lastx, x
DEFINT lasty, y
DEFINT lastr, r, r1
lastx=100: lasty=100: lastr=8
x=lastx: y=lasty: r=lastr

DIM MyFont As FONT
MyFont.Name="FixedSys"

DIM form As FORM
form.resizeable=false: form.maximizebox=false
form.width=508: form.height=254
form.caption="HotBasic Draw Test 1.8"
form.icon="hotbasic.ico"
cHeight = form.ClientHeight
cWidth = form.ClientWidth

DIM hb as IMAGE
with hb
.top=10: .left=10: .bmp="hot_basic"
end with

DIM bb as BUTTON
with bb
.top=10: .left=100: .width=100: .height=30
.caption="hide CANVAS"
.onclick=bclick
end with

DIM cv As CANVAS
cv.top=0: cv.left=0
cv.Height = cHeight
cv.Width = 220
cv.Font = MyFont
cv.OnPaint=DrawIt

DIM dot As CANVAS
dot.top=10: dot.left=210
dot.Height = cHeight-18: dot.Width = 190
dWidth=dot.Width: dHeight=dot.Height
dot.OnPaint=DrawDot

DIM pic As CANVAS
with pic
.top=10: .left=410
.Height = 80: .Width = 80
.visible = false
.OnPaint=DrawPic
end with

DIM motion As TIMER
with motion
.repeated=true: .interval=100: .ontimer=MoveDot
end with

form.Show
hDC = dot.GetDC  'hDC is device context handle
tcolor=dot.Pixel(2,2)  '"transparent" (background) color
dot.ReleaseDC

SHOWMESSAGE "CANVAS is transparent"

motion.Enabled = true
pic.visible = true
form.Showmodal
END

bclick:
k=abs(k-1)
cv.visible=k
IF k THEN bb.caption="hide CANVAS" ELSE bb.caption="show CANVAS"
RETURN

DrawIt:
for i=110 to 190: cv.pset(i,32)=&HFFFFFF: next i
for i=110 to 190: cv.pset(i,44)=&HFF: next i
for i=110 to 190: cv.pset(i,56)=&HFF00: next i
for i=110 to 190: cv.pset(i,68)=&HFF0000: next i
for i=110 to 190: cv.pset(i,80)=0: next i
cv.Rectangle 10,10,90,90,&HFFFFFF
cv.Line 10,100,100,150,255
cv.Ellipse 10,100,200,150,&HFFFFFF
cv.Rectangle 100,100,200,150,&HFF00
cv.FillEllipse 10,170,50,220,&HFFFFFF
cv.FillCircle 75,195,25,&HFF
cv.FillRect 100,170,200,220,&HFFA040
cv.TextOut 110,118,"Hot! Basic",255,&HDDFFFF
cv.TextOut 110,188,"is in town",&HFF00,0
RETURN

MoveDot:
j=sgn(RND-.5045): x=lastx+j*RND(16) 
j=sgn(RND-.5045): y=lasty+j*RND(16)
j=sgn(RND-.5045): r=lastr+j*RND(2)
r1=r: INC(r1)
IF r<4 THEN r=4
IF r>20 THEN r=20
IF x<r1 THEN x=r1
IF y<r1 THEN y=r1
IF x>dWidth-r1 THEN x=dWidth-r1
IF y>dHeight-r1 THEN y=dHeight-r1
dot.RePaint
j=mybmp.x: INC(j)
IF j>310 THEN j=0
mybmp.x=j
pic.RePaint
RETURN

DrawDot:
'try to use constants and variables here for speed,
'not function calls (e.g.,dot.Width is a function call).
dot.Rectangle 0,0,dWidth,dHeight,0
dot.FillCircle lastx,lasty,lastr,tcolor
dot.FillCircle x,y,r,&H88FFFF
lastx=x: lasty=y: lastr=r
RETURN

DrawPic:
pic.Draw 0,0,mybmp
RETURN
